//@line 2 "/builds/songbird/release/branch_0_2/sb_branch_0_2_lincoln_release/branch_0_2/app/preferences/songbird-prefs.js.in"
// Songbird Default Prefs.

// DON'T CHANGE THIS.  This is not "bones".
pref("toolkit.defaultChromeURI", "chrome://songbird/content/xul/songbird.xul");
pref("toolkit.defaultChromeFeatures", "chrome,modal=no,toolbar=no,popup=no,titlebar=no,dialog=no");

// This is only used by the MAC version
pref("browser.chromeURL", "chrome://songbird/content/xul/macCmdLineFwd.xul");

// Prevent xulrunner from launching multiple instances of Songbird.
pref("toolkit.singletonWindowType", "Songbird:Main");

pref("general.useragent.extra.songbird", "Songbird/0.2.5.1 (20070301190953)");
pref("general.skins.selectedSkin", "rubberducky/0.2");

// Interim "bones" implementation
pref("general.bones.selectedMainWinURL", "chrome://rubberducky/content/xul/mainwin.xul");
pref("general.bones.selectedMiniPlayerURL", "chrome://rubberducky/content/xul/miniplayer.xul");

// Our skinswitching trick doesn't work unless we shut down the XUL cache.
pref("nglayout.debug.disable_xul_cache", true);

// Dump the current ram footprint when minimized.
pref("config.trim_on_minimize", true);

// Scan for some extra plugins.
pref("plugin.scan.SunJRE", "1.3");
pref("plugin.scan.Acrobat", "5.0");
pref("plugin.scan.Quicktime", "5.0");
pref("plugin.scan.WindowsMediaPlayer", "7.0");

// Password Manager
pref("signon.rememberSignons", true);
pref("signon.expireMasterPassword", false);
pref("signon.SignonFileName", "signons.txt");

pref("browser.shell.checkDefaultBrowser", false);

pref("browser.formfill.enable", true);

pref("browser.search.update", false);
pref("browser.search.update.log", false);
pref("browser.search.updateinterval", 6);

pref("browser.sessionhistory.max_total_viewers", 0);
pref("browser.sessionhistory.max_entries", 50);

pref("browser.xul.error_pages.enabled", true);

// Download manager prefs
pref("browser.download.useDownloadDir", true);
     // 0-desktop  1-download  2-pref("browser.download.dir")
pref("browser.download.folderList", 0);
pref("browser.download.manager.showAlertOnComplete", false);
pref("browser.download.manager.showAlertInterval", 2000);
     // when downloads are removed from list 0-completion 1-shutdown 2-never
pref("browser.download.manager.retention", 3);
     // these two control whether the manager shows up, both must be true
pref("browser.download.manager.showWhenStarting", true);
pref("browser.download.manager.useWindow", true);
     // duh
pref("browser.download.manager.closeWhenDone", false);
     // how long to wait before showing dm
pref("browser.download.manager.openDelay", 0);
pref("browser.download.manager.focusWhenStarting", false);
     // flashes this many times when opened - in theory
pref("browser.download.manager.flashCount", 2);
//pref("privacy.item.downloads",  true);
//pref("browser.download.show_plugins_in_list", true);
//pref("browser.download.hide_plugins_without_extensions", true);


//pref("browser.link.open_external", 3);
//pref("browser.link.open_newwindow", 3);
//pref("browser.link.open_newwindow.restriction", 2);
//pref("browser.tabs.loadInBackground", true);

// Dynamic Skin Switching
pref("extensions.dss.enabled", false);

// Non-dynamic switch pending after next restart
pref("extensions.dss.switchPending", false);

pref("general.autoScroll", false);
pref("general.smoothScroll", false);

// this will automatically enable inline spellchecking (if it is available) for
// editable elements in HTML
// 0 = spellcheck nothing
// 1 = check multi-line controls [default]
// 2 = check multi/single line controls
pref("layout.spellcheckDefault", 1);

pref("network.protocol-handler.external.mailto", true);
pref("network.protocol-handler.external.news", true);
pref("network.protocol-handler.external.snews", true);
pref("network.protocol-handler.external.nntp", true);

// Don't warn when opening external http urls
// This is to allow for launching _blank targeted links in the default browser
pref("network.protocol-handler.warn-external.http", false);
pref("network.protocol-handler.warn-external.https", false);

pref("network.proxy.share_proxy_settings",  false);

pref("plugin.default_plugin_disabled", true);
pref("security.warn_entering_secure.show_once", true);
pref("security.warn_leaving_secure.show_once", true);


// Prefer a window size that can handle 1024px-ish websites
// If this pref turns out to be bigger than the screen 
// the window size will fall back to that specified by css
pref("songbird.window.frame_outer.w", "1157");
pref("songbird.window.frame_outer.h", "718");

// Whether or not app updates are enabled
pref("app.update.enabled", true);

// This preference turns on app.update.mode and allows automatic download and
// install to take place. We use a separate boolean toggle for this to make
// the UI easier to construct.
pref("app.update.auto", true);

// Defines how the Application Update Service notifies the user about updates:
//
// AUM Set to:        Minor Releases:     Major Releases:
// 0                  download no prompt  download no prompt
// 1                  download no prompt  download no prompt if no incompatibilities
// 2                  download no prompt  prompt
//
// See chart in nsUpdateService.js.in for more details
//
pref("app.update.mode", 1);

// If set to true, the Update Service will present no UI for any event.
pref("app.update.silent", false);

// Update service URL:
// XXXben Remove hardcoded 'en-US' once locales are fixed properly. See bug 994.
pref("app.update.url", "https://updates.songbirdnest.com/update/1/%PRODUCT%/%VERSION%/%BUILD_ID%/%BUILD_TARGET%/en-US/%CHANNEL%/update.xml");

// URL user can browse to manually if for some reason all update installation
// attempts fail.  TODO: Change this URL
pref("app.update.url.manual", "http://www.songbirdnest.com/home");

// A default value for the "More information about this update" link
// supplied in the "An update is available" page of the update wizard. 
pref("app.update.url.details", "http://www.songbirdnest.com/home");

// User-settable override to app.update.url for testing purposes.
//pref("app.update.url.override", "");

// Interval: Time between checks for a new version (in seconds)
//           default=1 day
pref("app.update.interval", 86400);

// Interval: Time before prompting the user to download a new version that 
//           is available (in seconds) default=1 day
pref("app.update.nagTimer.download", 86400);

// Interval: Time before prompting the user to restart to install the latest
//           download (in seconds) default=30 minutes
pref("app.update.nagTimer.restart", 1800);

// Interval: When all registered timers should be checked (in milliseconds)
//           default=5 seconds
pref("app.update.timer", 600000);

// Whether or not we show a dialog box informing the user that the update was
// successfully applied. This is off in Firefox by default since we show a 
// upgrade start page instead! Other apps may wish to show this UI, and supply
// a whatsNewURL field in their brand.properties that contains a link to a page
// which tells users what's new in this new update.
pref("app.update.showInstalledUI", false);

// 0 = suppress prompting for incompatibilities if there are updates available
//     to newer versions of installed addons that resolve them.
// 1 = suppress prompting for incompatibilities only if there are VersionInfo
//     updates available to installed addons that resolve them, not newer
//     versions.
pref("app.update.incompatible.mode", 0);

// Symmetric (can be overridden by individual extensions) update preferences.
// e.g.
//  extensions.{GUID}.update.enabled
//  extensions.{GUID}.update.url
//  extensions.{GUID}.update.interval
//  .. etc ..
//
pref("extensions.update.enabled", true);
pref("extensions.update.url", "chrome://branding/locale/brand.properties");
pref("extensions.update.interval", 86400);  // Check for updates to Extensions and 
                                            // Feathers every week
// Non-symmetric (not shared by extensions) extension-specific [update] preferences
pref("extensions.getMoreExtensionsURL", "chrome://branding/locale/brand.properties");
pref("extensions.getMoreThemesURL", "chrome://branding/locale/brand.properties");

pref("extensions.blocklist.enabled", true);
pref("extensions.blocklist.interval", 86400);
pref("extensions.blocklist.url", "http://addons.songbirdnest.com/blocklist/1/%APP_ID%/%APP_VERSION%/");
pref("extensions.blocklist.detailsURL", "http://addons.songbirdnest.com/blocklist/");
pref("extensions.ignoreMTimeChanges", false);

pref("xpinstall.whitelist.add", "addons.songbirdnest.com");
pref("xpinstall.whitelist.add.103", "addons.songbirdnest.com");
//@line 119 "/builds/songbird/release/branch_0_2/sb_branch_0_2_lincoln_release/branch_0_2/app/preferences/songbird-prefs.js.in"

//@line 123 "/builds/songbird/release/branch_0_2/sb_branch_0_2_lincoln_release/branch_0_2/app/preferences/songbird-prefs.js.in"

//@line 127 "/builds/songbird/release/branch_0_2/sb_branch_0_2_lincoln_release/branch_0_2/app/preferences/songbird-prefs.js.in"
pref("browser.preferences.instantApply", true);
//@line 129 "/builds/songbird/release/branch_0_2/sb_branch_0_2_lincoln_release/branch_0_2/app/preferences/songbird-prefs.js.in"

//@line 133 "/builds/songbird/release/branch_0_2/sb_branch_0_2_lincoln_release/branch_0_2/app/preferences/songbird-prefs.js.in"
pref("browser.preferences.animateFadeIn", false);
//@line 135 "/builds/songbird/release/branch_0_2/sb_branch_0_2_lincoln_release/branch_0_2/app/preferences/songbird-prefs.js.in"

// Enable the web playlist.
// Extracts A tags and add browser context menu.
// Note that this pref is reset to "1" on every app start. 
pref("songbird.webplaylist.enabled", "1");

// Override the window XPInstall opens on extension install
pref("xpinstall.dialog.progress.type.chrome", "Browser:Preferences");
pref("xpinstall.dialog.progress.type.skin", "Browser:Preferences");

+// use Thunderbird as the default external email app
+pref("network.protocol-handler.app.mailto", "/usr/bin/thunderbird");
